/*

			Millennium Screen Saver

*/

#include "milscrsv.h"

/* Function prototypes */

static void WriteProfileInt(LPSTR key, LPSTR tag, int i);

/* Global used by SCRNSAVE.LIB. Required for all screen savers. */

char szAppName[40];

/* Globals exported. */

char szName[]="Millennium Screen Saver";

/* Externals defined in SCRNSAVE.LIB. Required for all screen savers. */

HINSTANCE hMainInstance;
HWND hMainWindow;
char szName[TITLEBARNAMELEN];
char szIniFile[MAXFILELEN];
char szScreenSaver[22];
char szHelpFile[MAXFILELEN];
char szNoHelpMemory[BUFFLEN];
UINT MyHelpMessage;
HOOKPROC fpMessageFilter;

/* RegisterDialogClasses -- Entry point for registering window
							classes required by configuration dialog box. */

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
    return TRUE;
}

/* ScreenSaverConfigureDialog -- Dialogue box function for
								 screen saver configuration dialogue. */

DialogueProc(ScreenSaverConfigureDialog)
{
	static HWND hIDOK;
	BOOL intok;
	int is;

    switch (message) {
        case WM_INITDIALOG:
            GetIniEntries();
            GetIniSettings();

			/*	If the theme resource is not present, this is the
				"lite" version.  Disable the play theme check box.  */

			findThemeFile();
			if (themeFileIndex == 0) {
				EnableWindow(GetDlgItem(hDlg, IDC_CO_PLAYTHEME), FALSE);
			}
#ifdef LITE
			CheckDlgButton(hDlg, IDC_CO_PLAYTHEME, FALSE);
#else
			CheckDlgButton(hDlg, IDC_CO_PLAYTHEME, playTheme);
#endif			
			CheckDlgButton(hDlg, IDC_CO_CHIME_START, startChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_HOUR, hourChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_HALF, halfHourChime); 
			CheckDlgButton(hDlg, IDC_CO_CHIME_EXIT, exitChime); 
			CheckDlgButton(hDlg, IDC_CO_DATE_TIME, showDateTime); 
			CheckDlgButton(hDlg, IDC_CO_Y2000, millenniumStarts == 0); 
			CheckDlgButton(hDlg, IDC_CO_Y2001, millenniumStarts);
			CheckDlgButton(hDlg, IDC_CO_COUNT_TODAY, countToday); 
			CheckDlgButton(hDlg, IDC_CO_TESTMODE, testMode);

			if (imageSize == 0) {
				SetDlgItemText(hDlg, IDC_IMAGE_SIZE, rstring(IDS_AUTO));
			} else {
				SetDlgItemInt(hDlg, IDC_IMAGE_SIZE, imageSize, FALSE);
			}

            hIDOK = GetDlgItem(hDlg, IDOK);
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
#ifdef LITE
					playTheme = TRUE;
#else
					playTheme = IsDlgButtonChecked(hDlg, IDC_CO_PLAYTHEME);
#endif
					startChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_START);
					hourChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_HOUR);
					halfHourChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_HALF);
					exitChime = IsDlgButtonChecked(hDlg, IDC_CO_CHIME_EXIT);
					showDateTime = IsDlgButtonChecked(hDlg, IDC_CO_DATE_TIME);
					millenniumStarts = IsDlgButtonChecked(hDlg, IDC_CO_Y2001);
					countToday = IsDlgButtonChecked(hDlg, IDC_CO_COUNT_TODAY);
					testMode = IsDlgButtonChecked(hDlg, IDC_CO_TESTMODE);

					is = GetDlgItemInt(hDlg, IDC_IMAGE_SIZE, &intok, FALSE);
					if (intok) {
						imageSize = is;
					} else {
						imageSize = 0;
					}
					
					/* Write out all configuration parameters. */
                    
					WriteProfileInt(szAppName, rstring(INI_PLAYTHEME), playTheme);
					WriteProfileInt(szAppName, rstring(INI_STARTCHIME), startChime);
					WriteProfileInt(szAppName, rstring(INI_HOURCHIME), hourChime);  
					WriteProfileInt(szAppName, rstring(INI_HALFHOURCHIME), halfHourChime);
					WriteProfileInt(szAppName, rstring(INI_EXITCHIME), exitChime);
					WriteProfileInt(szAppName, rstring(INI_DATE_TIME), showDateTime);
					WriteProfileInt(szAppName, rstring(INI_TESTMODE), testMode);
					WriteProfileInt(szAppName, rstring(INI_WHICHYEAR), millenniumStarts);
					WriteProfileInt(szAppName, rstring(INI_COUNT_TODAY), countToday);
					WriteProfileInt(szAppName, rstring(INI_IMAGESIZE), imageSize);
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    return TRUE;

                case ID_HELP:
DoHelp:
                    MessageBox(hDlg, "Millennium screen saver.", szName, MB_OK);
                    break;
            }
            break;

        default:
            if (message == MyHelpMessage)     // Context sensitive help msg.
                goto DoHelp;
    }
    return FALSE;
}

/* GetIniSettings -- Get initial settings from WIN.INI

	Params:  hWnd -- Handle to window

	Return:  None
	
	Note that initial installation defaults are set by the default
	arguments to the retrievals of the profile variables.
*/

void GetIniSettings(void)
{
    playTheme = GetPrivateProfileInt(szAppName, rstring(INI_PLAYTHEME), TRUE, szIniFile); 
    startChime = GetPrivateProfileInt(szAppName, rstring(INI_STARTCHIME), TRUE, szIniFile); 
    hourChime = GetPrivateProfileInt(szAppName, rstring(INI_HOURCHIME), TRUE, szIniFile); 
    halfHourChime = GetPrivateProfileInt(szAppName, rstring(INI_HALFHOURCHIME), TRUE, szIniFile);
	exitChime = GetPrivateProfileInt(szAppName, rstring(INI_EXITCHIME), TRUE, szIniFile);
	showDateTime = GetPrivateProfileInt(szAppName, rstring(INI_DATE_TIME), TRUE, szIniFile);
	testMode = GetPrivateProfileInt(szAppName, rstring(INI_TESTMODE), FALSE, szIniFile);
	millenniumStarts = GetPrivateProfileInt(szAppName, rstring(INI_WHICHYEAR), 0, szIniFile);
	countToday = GetPrivateProfileInt(szAppName, rstring(INI_COUNT_TODAY), TRUE, szIniFile);
	imageSize = GetPrivateProfileInt(szAppName, rstring(INI_IMAGESIZE), 0, szIniFile);
}

/* WriteProfileInt - Write an unsigned integer value to CONTROL.INI.

	Params:  name - szSection - [section] name in .INI file
		            szKey     - key= in .INI file
					i         - value for key above

	Return:  None
*/

static void WriteProfileInt(LPSTR szSection, LPSTR szKey, int i)
{
    char achBuf[40];

    /* Write out as unsigned because GetPrivateProfileInt() can't
       cope with signed values! */

    wsprintf(achBuf, "%u", i);
    WritePrivateProfileString(szSection, szKey, achBuf, szIniFile);
}

void GetIniEntries(void)
{
	// Load common strings from stringtable...
    LoadString(hMainInstance, idsAppName, szAppName, 40); 
	LoadString(hMainInstance, idsIniFile, szIniFile, MAXFILELEN);
	LoadString(hMainInstance, idsScreenSaver, szScreenSaver, 22);
	LoadString(hMainInstance, idsHelpFile, szHelpFile, MAXFILELEN);
	LoadString(hMainInstance, idsNoHelpMemory, szNoHelpMemory, BUFFLEN);
}
